<script lang="ts" setup>
import { cloneDeep, isEmpty } from 'lodash-es'
import { ref } from 'vue'
import DialogBox from '@/components/dialog-box/index.vue'
// 定义组件属性，默认 confirmText 为 '确定'
const props = withDefaults(defineProps<{
  confirmText?: string;
  title: string,
  type?: 'category' | 'move'
}>(), {
  confirmText: '确定',
  type: 'category'
})

// 定义组件事件，允许触发 submitHandle 事件
const emit = defineEmits(['submitHandle'])

// 定义一个响应式变量 dialogVisible，用于控制对话框的显示和隐藏
const dialogVisible = ref<boolean>(false)
// 定义一个响应式变量 formData，用于存储表单数据
const formData = ref<any>({})
// 定义一个响应式变量 formDataRef，用于引用表单实例
const formDataRef = ref<any>(null)

// 定义一个响应式变量 loading，用于控制按钮的加载状态
const loading = ref<boolean>(false)

// 关闭对话框的方法
const close = () => {
  dialogVisible.value = false;
  formData.value = {};
}
// 关闭对话框的方法
const open = (query?: any) => {
  dialogVisible.value = true
  if (!isEmpty(query)) {
    formData.value = cloneDeep(query);
  }
}

// 提交表单的方法
const submitHandle = async () => {
  try {
    await formDataRef.value.validate()
    // 触发 submitHandle 事件，传递表单数据
    emit('submitHandle', formData.value)
  } catch (e) {
    console.log(e)
  }
}
// 暴露 open 和 closeDialog 方法给外部使用
defineExpose({ open, close })
</script>

<template>
  <dialog-box :dialogVisible="dialogVisible" :title="title" width="500">
   <el-row :gutter="20">

   </el-row>
    <template #footer>
      <span class="dialog-footer res_el-dialog__footer">
        <el-button :loading="loading" @click.prevent="close"> 取消 </el-button>
        <el-button :loading="loading" type="primary" @click="submitHandle()">
          保存
        </el-button>
      </span>
    </template>
  </dialog-box>
</template>

<style lang="scss" scoped></style>
